const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const loan_applications = sequelize.define(
    'loan_applications',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      amount: {
        type: DataTypes.DECIMAL,
      },

      loan_type: {
        type: DataTypes.ENUM,

        values: [
          'CariGiderler',

          'YatırımGiderleri',

          'MalAlımı',

          'KrediliAlışVeriş',

          'TeminatMektubu',
        ],
      },

      application_date: {
        type: DataTypes.DATE,
      },

      approved: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  loan_applications.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.loan_applications.belongsTo(db.partners, {
      as: 'partner',
      foreignKey: {
        name: 'partnerId',
      },
      constraints: false,
    });

    db.loan_applications.belongsTo(db.kooperatif, {
      as: 'kooperatif',
      foreignKey: {
        name: 'kooperatifId',
      },
      constraints: false,
    });

    db.loan_applications.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.loan_applications.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return loan_applications;
};
